Index: mapstorage.cc
===================================================================
--- mapstorage.cc	(revision 201)
+++ mapstorage.cc	(revision 184)
@@ -721,158 +416,68 @@
 void MapStorage::writeToFile(const std::string &filename)
 {
-  // relabel nodes and edges
-  int i = 0;
-  for (NodeIt n(graph); n != INVALID; ++n)
-  {
-    node_label[n] = i++;
-  }
-  max_node_label = i-1;
-  i = 0;
-  for (EdgeIt e(graph); e != INVALID; ++e)
-  {
-    edge_label[e] = i++;
-  }
-  max_edge_label = i-1;
-
-  // write .lgf file
-  {
-    GraphWriter<Graph> gwriter(filename, graph);
-
-    gwriter.writeNodeMap("label", node_label);
-    gwriter.writeEdgeMap("label", edge_label);
-
-    // write node maps
-    for (NodeMapStore::const_iterator it = nodemaps.begin();
-        it != nodemaps.end(); ++it)
-    {
-      if (it->second->save_dest == NESET_SECT)
-      {
-        switch (it->second->type())
-        {
-          case MapValue::NUMERIC:
-            gwriter.writeNodeMap(it->first, getNumericNodeMap(it->first));
-            break;
-          case MapValue::STRING:
-            gwriter.writeNodeMap(it->first, getStringNodeMap(it->first));
-            break;
-        }
-      }
-    }
-
-    // write edge maps
-    for (EdgeMapStore::const_iterator it = edgemaps.begin();
-        it != edgemaps.end(); ++it)
-    {
-      if (it->second->save_dest == NESET_SECT)
-      {
-        switch (it->second->type())
-        {
-          case MapValue::NUMERIC:
-            gwriter.writeEdgeMap(it->first, getNumericEdgeMap(it->first));
-            break;
-          case MapValue::STRING:
-            gwriter.writeEdgeMap(it->first, getStringEdgeMap(it->first));
-            break;
-        }
-      }
-    }
-
-    // write node coordinates
-    switch (getNodeCoordsSaveDest())
-    {
-      case MapStorage::SpecMapSaveOpts::GUI_SECT:
-        break;
-      case MapStorage::SpecMapSaveOpts::NESET_SECT:
-        switch (getNodeCoordsSaveMapNum())
-        {
-          case MapStorage::SpecMapSaveOpts::ONE_MAP:
-            gwriter.writeNodeMap(node_coords_one_map_name + ":x",
-                node_coords_x);
-            gwriter.writeNodeMap(node_coords_one_map_name + ":y",
-                node_coords_y);
-            break;
-          case MapStorage::SpecMapSaveOpts::TWO_MAPS:
-            gwriter.writeNodeMap(node_coords_two_maps_1_name,
-                node_coords_x);
-            gwriter.writeNodeMap(node_coords_two_maps_2_name,
-                node_coords_y);
-            break;
-        }
-        break;
-    }
-
-    // write arrow coordinates
-    switch (getArrowCoordsSaveDest())
-    {
-      case MapStorage::SpecMapSaveOpts::GUI_SECT:
-        break;
-      case MapStorage::SpecMapSaveOpts::NESET_SECT:
-        switch (getArrowCoordsSaveMapNum())
-        {
-          case MapStorage::SpecMapSaveOpts::ONE_MAP:
-            gwriter.writeEdgeMap(arrow_coords_one_map_name + ":x",
-                arrow_coords_x);
-            gwriter.writeEdgeMap(arrow_coords_one_map_name + ":y",
-                arrow_coords_y);
-            break;
-          case MapStorage::SpecMapSaveOpts::TWO_MAPS:
-            gwriter.writeEdgeMap(arrow_coords_two_maps_1_name,
-                arrow_coords_x);
-            gwriter.writeEdgeMap(arrow_coords_two_maps_2_name,
-                arrow_coords_y);
-            break;
-        }
-        break;
-    }
-
-    if (gui_sect_save_dest == LGF_FILE)
-    {
-      GuiWriter gui_writer(gwriter, this);
-      gwriter.run();
-    }
-    else
-    {
-      gwriter.run();
-    }
-  }
-
-  // write .conf file
-  if (gui_sect_save_dest == CONF_FILE)
-  {
-    LemonWriter lwriter(filename + ".conf");
-    GuiWriter gui_writer(lwriter, this);
-    lwriter.run();
-  }
+  GraphWriter<Graph> gwriter(filename, graph);
+
+  for (std::map<std::string, Graph::NodeMap<double>*>::const_iterator it =
+      nodemap_storage.begin(); it != nodemap_storage.end(); ++it)
+  {
+    gwriter.writeNodeMap(it->first, *(it->second));
+  }
+  for (std::map<std::string, Graph::EdgeMap<double>*>::const_iterator it =
+      edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
+  {
+    if ((it->first != "arrow_pos_x") &&
+        (it->first != "arrow_pos_y"))
+    {
+      gwriter.writeEdgeMap(it->first, *(it->second));
+    }
+  }
+
+  GuiWriter gui_writer(gwriter, this);
+
+  gwriter.run();
 }
 
 void MapStorage::clear()
 {
-  for (NodeMapStore::iterator it = nodemaps.begin(); it != nodemaps.end(); ++it)
-  {
-    delete it->second;
-    nodemaps.erase(it);
-  }
-  for (EdgeMapStore::iterator it = edgemaps.begin(); it != edgemaps.end(); ++it)
-  {
-    delete it->second;
-    edgemaps.erase(it);
+  for (std::map<std::string, Graph::NodeMap<double>*>::iterator it =
+      nodemap_storage.begin(); it != nodemap_storage.end(); ++it)
+  {
+    if ((it->first != "coordinates_x") &&
+        (it->first != "coordinates_y") &&
+        (it->first != "label"))
+    {
+      delete it->second;
+      nodemap_storage.erase(it);
+    }
+  }
+  for (std::map<std::string, Graph::EdgeMap<double>*>::iterator it =
+      edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
+  {
+    if ((it->first != "label") &&
+        (it->first != "arrow_pos_x") &&
+        (it->first != "arrow_pos_y"))
+    {
+      delete it->second;
+      edgemap_storage.erase(it);
+    }
+  }
+  for (std::map<std::string, double>::iterator it =
+      nodemap_default.begin(); it != nodemap_default.end(); ++it)
+  {
+    if (it->first != "label")
+      nodemap_default.erase(it);
+  }
+  for (std::map<std::string, double>::iterator it =
+      edgemap_default.begin(); it != edgemap_default.end(); ++it)
+  {
+    if (it->first != "label")
+      edgemap_default.erase(it);
   }
   graph.clear();
   file_name = "";
   modified = false;
-  max_node_label = 0;
-  max_edge_label = 0;
-  background_set = false;
-
-  gui_sect_save_dest = LGF_FILE;
-  node_coords_save_dest = SpecMapSaveOpts::GUI_SECT;
-  arrow_coords_save_dest = SpecMapSaveOpts::GUI_SECT;
-  node_coords_one_map_name = "coord";
-  node_coords_two_maps_1_name = "coord_x";
-  node_coords_two_maps_2_name = "coord_y";
-  arrow_coords_one_map_name = "arrow";
-  arrow_coords_two_maps_1_name = "arrow_x";
-  arrow_coords_two_maps_2_name = "arrow_y";
-
+
+  arrow_pos_read_ok = false;
+  
   for(int i=0;i<NODE_PROPERTY_NUM;i++)
     {
@@ -894,26 +499,31 @@
 }
 
+void MapStorage::ArrowPosReadOK()
+{
+  arrow_pos_read_ok = true;
+}
+
 void MapStorage::mapChanged(bool itisedge, std::string mapname)
 {
   if(itisedge)
-  {
-    for(int i=0;i<EDGE_PROPERTY_NUM;i++)
-    {
-      if(active_edgemaps[i]==mapname)
-      {
-        signal_prop.emit(itisedge, i);
-      }
-    }
-  }
+    {
+      for(int i=0;i<EDGE_PROPERTY_NUM;i++)
+	{
+	  if(active_edgemaps[i]==mapname)
+	    {
+	      signal_prop.emit(itisedge, i);
+	    }
+	}
+    }
   else
-  {
-    for(int i=0;i<NODE_PROPERTY_NUM;i++)
-    {
-      if(active_nodemaps[i]==mapname)
-      {
-        signal_prop.emit(itisedge, i);
-      }
-    }
-  }
+    {
+      for(int i=0;i<NODE_PROPERTY_NUM;i++)
+	{
+	  if(active_nodemaps[i]==mapname)
+	    {
+	      signal_prop.emit(itisedge, i);
+	    }
+	}
+    }
 }
 
@@ -945,477 +555,4 @@
 }
 
-XY MapStorage::getNodeCoords(Node n) const
-{
-  return node_coords[n];
-}
-
-void MapStorage::setNodeCoords(Node n, XY c)
-{
-  node_coords.set(n, c);
-}
-
-XY MapStorage::getArrowCoords(Edge e) const
-{
-  return arrow_coords[e];
-}
-
-void MapStorage::setArrowCoords(Edge e, XY c)
-{
-  arrow_coords.set(e, c);
-}
-
-MapValue MapStorage::get(const std::string& name, Node node) const
-{
-  NodeMapData* data = getNodeMapData(name);
-  return data->get(node);
-}
-
-void MapStorage::set(const std::string& name, Node node, MapValue val)
-{
-  NodeMapData* data = getNodeMapData(name);
-  data->set(node, val);
-}
-
-MapValue MapStorage::get(const std::string& name, Edge edge) const
-{
-  EdgeMapData* data = getEdgeMapData(name);
-  return data->get(edge);
-}
-
-void MapStorage::set(const std::string& name, Edge edge, MapValue val)
-{
-  EdgeMapData* data = getEdgeMapData(name);
-  data->set(edge, val);
-}
-
-const std::string& MapStorage::getFileName() const
-{
-  return file_name;
-}
-
-void MapStorage::setFileName(const std::string& fn)
-{
-  file_name = fn;
-}
-
-bool MapStorage::getModified() const
-{
-  return modified;
-}
-
-void MapStorage::setModified(bool m)
-{
-  modified = m;
-}
-
-Node MapStorage::addNode(XY coords)
-{
-  Node node = graph.addNode();
-
-  setNodeCoords(node, coords);
-
-  max_node_label++;
-
-  node_label[node] = max_node_label;
-
-  std::vector<std::string> node_maps = getNodeMapList();
-  for (std::vector<std::string>::const_iterator it = node_maps.begin();
-      it != node_maps.end(); ++it)
-  {
-    NodeMapData* data = getNodeMapData(*it);
-    set(*it, node, data->default_value);
-  }
-
-  return node;
-}
-
-Edge MapStorage::addEdge(Node from, Node to)
-{
-  Edge edge = graph.addEdge(from, to);
-
-  if (from == to)
-  {
-    setArrowCoords(edge, getNodeCoords(from) + XY(0.0, 80.0));
-  }
-  else
-  {
-    setArrowCoords(edge, (getNodeCoords(from) + getNodeCoords(to)) / 2.0);
-  }
-
-  max_edge_label++;
-
-  edge_label[edge] = max_edge_label;
-
-  std::vector<std::string> edge_maps = getEdgeMapList();
-  for (std::vector<std::string>::const_iterator it = edge_maps.begin();
-      it != edge_maps.end(); ++it)
-  {
-    EdgeMapData* data = getEdgeMapData(*it);
-    set(*it, edge, data->default_value);
-  }
-  return edge;
-}
-
-MapStorage::NumericNodeMap& MapStorage::getNumericNodeMap(const std::string& name)
-{
-  NodeMapData* data = getNodeMapData(name);
-  if (data->type() != MapValue::NUMERIC)
-    throw Error("Numeric node map " + name + " does not exists.");
-  return static_cast<NumericNodeMapData*>(data)->map;
-}
-
-MapStorage::StringNodeMap& MapStorage::getStringNodeMap(const std::string& name)
-{
-  NodeMapData* data = getNodeMapData(name);
-  if (data->type() != MapValue::STRING)
-    throw Error("String node map " + name + " does not exists.");
-  return static_cast<StringNodeMapData*>(data)->map;
-}
-
-MapStorage::NumericEdgeMap& MapStorage::getNumericEdgeMap(const std::string& name)
-{
-  EdgeMapData* data = getEdgeMapData(name);
-  if (data->type() != MapValue::NUMERIC)
-    throw Error("Numeric edge map " + name + " does not exists.");
-  return static_cast<NumericEdgeMapData*>(data)->map;
-}
-
-MapStorage::StringEdgeMap& MapStorage::getStringEdgeMap(const std::string& name)
-{
-  EdgeMapData* data = getEdgeMapData(name);
-  if (data->type() != MapValue::STRING)
-    throw Error("String edge map " + name + " does not exists.");
-  return static_cast<StringEdgeMapData*>(data)->map;
-}
-
-MapValueEdgeMap MapStorage::getEdgeMap(const std::string& name)
-{
-  return MapValueEdgeMap(name, this);
-}
-
-MapValueNodeMap MapStorage::getNodeMap(const std::string& name)
-{
-  return MapValueNodeMap(name, this);
-}
-
-int MapStorage::getLabel(Node n) const
-{
-  return node_label[n];
-}
-
-int MapStorage::getLabel(Edge e) const
-{
-  return edge_label[e];
-}
-
-MapStorage::GuiSectSaveDest MapStorage::getGUIDataSaveLocation()
-{
-  return gui_sect_save_dest;
-}
-
-void MapStorage::setGUIDataSaveLocation(MapStorage::GuiSectSaveDest dest)
-{
-  gui_sect_save_dest = dest;
-}
-
-MapStorage::MapSaveDest MapStorage::getNodeMapSaveDest(std::string name) const
-{
-  NodeMapData *data = getNodeMapData(name);
-  return data->save_dest;
-}
-
-MapStorage::MapSaveDest MapStorage::getEdgeMapSaveDest(std::string name) const
-{
-  EdgeMapData *data = getEdgeMapData(name);
-  return data->save_dest;
-}
-
-void MapStorage::setNodeMapSaveDest(std::string name, MapStorage::MapSaveDest dest)
-{
-  NodeMapData *data = getNodeMapData(name);
-  data->save_dest = dest;
-}
-
-void MapStorage::setEdgeMapSaveDest(std::string name, MapStorage::MapSaveDest dest)
-{
-  EdgeMapData *data = getEdgeMapData(name);
-  data->save_dest = dest;
-}
-
-MapStorage::EdgeMapData* MapStorage::getEdgeMapData(std::string name) const
-{
-  EdgeMapStore::const_iterator it = edgemaps.find(name);
-  if (it != edgemaps.end())
-    return it->second;
-  else
-    throw Error("Edge map " + name + " does not exists.");
-}
-
-MapStorage::NodeMapData* MapStorage::getNodeMapData(std::string name) const
-{
-  NodeMapStore::const_iterator it = nodemaps.find(name);
-  if (it != nodemaps.end())
-    return it->second;
-  else
-    throw Error("Node map " + name + " does not exists.");
-}
-
-MapValue::Type MapStorage::getNodeMapElementType(std::string name) const
-{
-  NodeMapData *data = getNodeMapData(name);
-  return data->type();
-}
-
-MapValue::Type MapStorage::getEdgeMapElementType(std::string name) const
-{
-  EdgeMapData *data = getEdgeMapData(name);
-  return data->type();
-}
-
-const MapStorage::NodeLabelMap& MapStorage::getNodeLabelMap()
-{
-  return node_label;
-}
-
-const MapStorage::EdgeLabelMap& MapStorage::getEdgeLabelMap()
-{
-  return edge_label;
-}
-
-const Graph& MapStorage::getGraph()
-{
-  return graph;
-}
-
-bool MapStorage::nodeMapExists(std::string name)
-{
-  NodeMapStore::const_iterator it = nodemaps.find(name);
-  if (it == nodemaps.end())
-    return false;
-  else
-    return true;
-}
-
-bool MapStorage::edgeMapExists(std::string name)
-{
-  EdgeMapStore::const_iterator it = edgemaps.find(name);
-  if (it == edgemaps.end())
-    return false;
-  else
-    return true;
-}
-
-std::vector<std::string> MapStorage::getEdgeMaps(MapType type)
-{
-  std::vector<std::string> maps;
-  for (EdgeMapStore::const_iterator it = edgemaps.begin(); it != edgemaps.end(); ++it)
-  {
-    if (it->second->type() & type)
-    {
-      maps.push_back(it->first);
-    }
-  }
-  return maps;
-}
-
-std::vector<std::string> MapStorage::getNodeMaps(MapType type)
-{
-  std::vector<std::string> maps;
-  for (NodeMapStore::const_iterator it = nodemaps.begin(); it != nodemaps.end(); ++it)
-  {
-    if (it->second->type() & type)
-    {
-      maps.push_back(it->first);
-    }
-  }
-  return maps;
-}
-
-MapStorage::NodeCoordMap& MapStorage::getNodeCoordMap()
-{
-  return node_coords;
-}
-
-MapStorage::ArrowCoordMap& MapStorage::getArrowCoordMap()
-{
-  return arrow_coords;
-}
-
-MapStorage::SpecMapSaveOpts::Dest MapStorage::getNodeCoordsSaveDest()
-{
-  return node_coords_save_dest;
-}
-
-MapStorage::SpecMapSaveOpts::Dest MapStorage::getArrowCoordsSaveDest()
-{
-  return arrow_coords_save_dest;
-}
-
-void MapStorage::setNodeCoordsSaveDest(MapStorage::SpecMapSaveOpts::Dest dest)
-{
-  node_coords_save_dest = dest;
-}
-
-void MapStorage::setArrowCoordsSaveDest(MapStorage::SpecMapSaveOpts::Dest dest)
-{
-  arrow_coords_save_dest = dest;
-}
-
-MapStorage::SpecMapSaveOpts::MapNum MapStorage::getNodeCoordsSaveMapNum()
-{
-  return node_coords_save_map_num;
-}
-
-MapStorage::SpecMapSaveOpts::MapNum MapStorage::getArrowCoordsSaveMapNum()
-{
-  return arrow_coords_save_map_num;
-}
-
-void MapStorage::setNodeCoordsSaveMapNum(MapStorage::SpecMapSaveOpts::MapNum num)
-{
-  node_coords_save_map_num = num;
-}
-
-void MapStorage::setArrowCoordsSaveMapNum(MapStorage::SpecMapSaveOpts::MapNum num)
-{
-  arrow_coords_save_map_num = num;
-}
-
-const std::string& MapStorage::getNodeCoordsOneMapName()
-{
-  return node_coords_one_map_name;
-}
-const std::string& MapStorage::getNodeCoordsTwoMaps1Name()
-{
-  return node_coords_two_maps_1_name;
-}
-const std::string& MapStorage::getNodeCoordsTwoMaps2Name()
-{
-  return node_coords_two_maps_2_name;
-}
-
-void MapStorage::setNodeCoordsOneMapName(const std::string& name)
-{
-  node_coords_one_map_name = name;
-}
-void MapStorage::setNodeCoordsTwoMaps1Name(const std::string& name)
-{
-  node_coords_two_maps_1_name = name;
-}
-void MapStorage::setNodeCoordsTwoMaps2Name(const std::string& name)
-{
-  node_coords_two_maps_2_name = name;
-}
-
-const std::string& MapStorage::getArrowCoordsOneMapName()
-{
-  return arrow_coords_one_map_name;
-}
-const std::string& MapStorage::getArrowCoordsTwoMaps1Name()
-{
-  return arrow_coords_two_maps_1_name;
-}
-const std::string& MapStorage::getArrowCoordsTwoMaps2Name()
-{
-  return arrow_coords_two_maps_2_name;
-}
-
-void MapStorage::setArrowCoordsOneMapName(const std::string& name)
-{
-  arrow_coords_one_map_name = name;
-}
-void MapStorage::setArrowCoordsTwoMaps1Name(const std::string& name)
-{
-  arrow_coords_two_maps_1_name = name;
-}
-void MapStorage::setArrowCoordsTwoMaps2Name(const std::string& name)
-{
-  arrow_coords_two_maps_2_name = name;
-}
-
-void MapStorage::readLGF(
-    const std::string& filename,
-    bool read_edge_label,
-    const std::vector<std::string>& node_map_names,
-    const std::vector<std::string>& edge_map_names,
-    const std::map<std::string, MapValue::Type>& node_map_types,
-    const std::map<std::string, MapValue::Type>& edge_map_types,
-    const std::string& node_coord_xmap_name,
-    const std::string& node_coord_ymap_name,
-    const std::string& arrow_coord_xmap_name,
-    const std::string& arrow_coord_ymap_name)
-{
-  using std::vector;
-  using std::map;
-  using std::string;
-
-  GraphReader<Graph> greader(filename, graph);
-
-  // read the label maps
-  greader.readNodeMap("label", node_label);
-  if (read_edge_label)
-    greader.readEdgeMap("label", edge_label);
-
-  // read the node maps
-  for (vector<string>::const_iterator
-      it = node_map_names.begin();
-      it != node_map_names.end(); ++it)
-  {
-    switch (node_map_types.find(*it)->second)
-    {
-      case MapValue::NUMERIC:
-        {
-          createNodeMap(*it, MapValue::NUMERIC, double());
-          greader.readNodeMap(*it, getNumericNodeMap(*it));
-          break;
-        }
-      case MapValue::STRING:
-        {
-          createNodeMap(*it, MapValue::STRING, string());
-          greader.readNodeMap(*it, getStringNodeMap(*it));
-          break;
-        }
-    }
-    getNodeMapData(*it)->save_dest = NESET_SECT;
-  }
-
-  // read the edge maps
-  for (vector<string>::const_iterator
-      it = edge_map_names.begin();
-      it != edge_map_names.end(); ++it)
-  {
-    switch (edge_map_types.find(*it)->second)
-    {
-      case MapValue::NUMERIC:
-        {
-          createEdgeMap(*it, MapValue::NUMERIC, double());
-          greader.readEdgeMap(*it, getNumericEdgeMap(*it));
-          break;
-        }
-      case MapValue::STRING:
-        {
-          createEdgeMap(*it, MapValue::STRING, string());
-          greader.readEdgeMap(*it, getStringEdgeMap(*it));
-          break;
-        }
-    }
-    getEdgeMapData(*it)->save_dest = NESET_SECT;
-  }
-
-  // read the node coordinate maps
-  if (node_coord_xmap_name != "")
-    greader.readNodeMap(node_coord_xmap_name, node_coords_x);
-  if (node_coord_ymap_name != "")
-    greader.readNodeMap(node_coord_ymap_name, node_coords_y);
-
-  // read the arrow coordinate maps
-  if (arrow_coord_xmap_name != "")
-    greader.readEdgeMap(arrow_coord_xmap_name, arrow_coords_x);
-  if (arrow_coord_ymap_name != "")
-    greader.readEdgeMap(arrow_coord_ymap_name, arrow_coords_y);
-
-  greader.run();
-}
-
 void MapStorage::setBackground(const std::string& file_name)
 {
@@ -1431,5 +568,5 @@
     background_set = true;
   }
-  signal_background.emit();
+  mytab.gd_canvas->setBackground();
 }
 
@@ -1453,94 +590,2 @@
   background_scaling = scaling;
 }
-
-void MapStorage::exportGraphToEPS(std::vector<bool> options, std::string filename, std::string shapemap)
-{
-  Graph::NodeMap<int> _shapes(graph, 0);
-  Graph::NodeMap<int> _nodeColors(graph, 0);
-  Graph::EdgeMap<int> _edgeColors(graph, 0);
-  Graph::NodeMap<double> _nodeSizes(graph, 6.0);
-  Graph::EdgeMap<double> _edgeWidths(graph, 1.0);
-  bool _drawArrows=options[ARROWS];
-  bool _enableParallel=options[PAR];
-
-  std::string emptyString="";
-  Graph::NodeMap<std::string> _nodeTextMap(graph,emptyString);
-
-  //_nodeTextMap=(Graph::NodeMap<void> *)&emptyStringMap;
-
-  if(options[N_MAPS])
-    {
-      if(active_nodemaps[N_RADIUS]!="")
-	{
-	  _nodeSizes=getNumericNodeMap(active_nodemaps[N_RADIUS]);
-	}
-      if(active_nodemaps[N_COLOR]!="")
-	{
-	  for(NodeIt ni(graph);ni!=INVALID;++ni)
-	    {
-	      _nodeColors[ni]=(int)get(active_nodemaps[N_COLOR], ni);
-	    }
-	}
-      if(active_nodemaps[N_TEXT]!="")
-	{
-	  for(NodeIt ni(graph);ni!=INVALID;++ni)
-	    {
-	      std::ostringstream o;
-	      o << get(active_nodemaps[N_TEXT], ni);
-	      _nodeTextMap[ni]=o.str();	      
-	    }
-	}
-    }
-  if(options[E_MAPS])
-    {
-      if(active_edgemaps[E_WIDTH]!="")
-	{
-	  _edgeWidths=getNumericEdgeMap(active_edgemaps[E_WIDTH]);
-	}
-      if(active_edgemaps[E_COLOR]!="")
-	{
-	  for(EdgeIt ei(graph);ei!=INVALID;++ei)
-	    {
-	      _edgeColors[ei]=(int)get(active_edgemaps[E_COLOR], ei);
-	    }
-	}
-    }
-  if(shapemap!="Default values")
-    {
-      double min = std::numeric_limits<double>::max();
-      double max = std::numeric_limits<double>::min();
-      for (NodeIt n(graph); n != INVALID; ++n)
-      {
-        double v = static_cast<double>(get(shapemap, n));
-        if (v < min) min = v;
-        if (v > max) max = v;
-      }
-      if((min>=0)&&(max<=4))
-	{
-          NumericNodeMap& map = static_cast<NumericNodeMapData*>(getNodeMapData(shapemap))->map;
-          for (NodeIt n(graph); n != INVALID; ++n)
-          {
-            _shapes[n] = static_cast<int>(map[n]);
-          }
-	}
-    }
-
-  Palette palette;
-  Palette paletteW(true);
-
-  graphToEps(graph,filename).
-    title("Sample .eps figure (fits to A4)").
-    copyright("(C) 2006 LEMON Project").
-    absoluteNodeSizes().absoluteEdgeWidths().
-    nodeScale(2).nodeSizes(_nodeSizes).
-    coords(node_coords).
-    nodeShapes(_shapes).
-    nodeColors(composeMap(paletteW,_nodeColors)).
-    edgeColors(composeMap(palette,_edgeColors)).
-    edgeWidthScale(0.3).edgeWidths(_edgeWidths).
-    nodeTexts(_nodeTextMap).nodeTextSize(7).
-    enableParallel(_enableParallel).parEdgeDist(5).
-    drawArrows(_drawArrows).arrowWidth(7).arrowLength(7).
-    run();
-
-}
